#include  <stdio.h>
#include  <stdlib.h>
#include  <time.h>
#include  <sys/time.h>
#ifdef NEWS
#include  "Nstdio.h"
#include  "Nsystime.h"
#include  <unistd.h>
#include <sys/types.h>
#include <sys/timeb.h>
#endif
#include  "countd.h"


time_t calc_diff(struct tm *sime_tms)
{
#ifndef NEWS
/*  FreeBSD, Linux ˤ뺹ʬ׻  */
	time_t from; /*  ߻ 1970 ǯηв  */
	time_t to;   /*  ᤭ 1970 ǯηв  */
	long sec_clock;
	struct tm *now_tmsp;
	struct timeval tp;
	struct timezone tzp;

	to = mktime(sime_tms);

	gettimeofday(&tp, &tzp);
	sec_clock = (long)tp.tv_sec;
	now_tmsp = localtime(&sec_clock);
	from = mktime(now_tmsp);

	return (to - from);
#else
/*  NEWS ˤ뺹ʬ׻  */
    long sec_clock;
    struct tm *loc_time;
    static int m_day[12] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};

    int set_y;
    int set_m;
    int set_d;
    int set_h;
    int set_min;
    int rem_d;
    int rem_h;
    int rem_min;
    int rem_sec;
    int m_counter, y_counter;

	struct timeval tp;
	struct timezone tzp;

/*    clock = time(NULL);  */
/*	     time ϡ1970ǯ 1 1 00:00:00GMT θߤޤǤηв
     ä֤ޤ  */
	gettimeofday(&tp, &tzp);
	sec_clock = tp.tv_sec;

/*    loc_time = (struct tm *)malloc(sizeof(struct tm));  */
    loc_time = localtime(&sec_clock);


    set_y = sime_tms->tm_year;
    set_m = sime_tms->tm_mon + 1;
    set_d = sime_tms->tm_mday;
    set_h = sime_tms->tm_hour;
    set_min = sime_tms->tm_min;
	

/*  Ȥꤢ(Ȥľ)  */
	if(loc_time->tm_year > set_y){
		return -1;
	}
	else if(loc_time->tm_year == set_y){
		if((loc_time->tm_mon + 1) > set_m){
			return -1;
		}
		else if((loc_time->tm_mon + 1) == set_m){
			if(loc_time->tm_mday > set_d){
				return -1;
			}
			else if(loc_time->tm_mday == set_d){
				if(loc_time->tm_hour > set_h){
					return -1;
				}
				else if(loc_time->tm_hour == set_h){
					if(loc_time->tm_min > set_min){
						return -1;
					}
				}
			}
		}
	}


    if((loc_time->tm_year == set_y) && ((loc_time->tm_mon + 1) == set_m)){
		rem_d =set_d - loc_time->tm_mday;
    }
    else{
		rem_d = m_day[loc_time->tm_mon] - loc_time->tm_mday;
		rem_d += set_d;
    }

    m_counter = loc_time->tm_mon + 2;
    y_counter = loc_time->tm_year;

    while(1){
		if(m_counter == 13){
			y_counter++;
			m_counter = 1;
		}
		if(y_counter > set_y){
			break;
		}
		if((y_counter == set_y) && (m_counter  >= set_m)){
			break;
		}

		rem_d += m_day[m_counter - 1];
		if((m_counter == 2) && ((y_counter % 4) == 0)){
			rem_d++;
		}
		
		m_counter++;
    }
	
    rem_h = 0;
	
    if(set_min < loc_time->tm_min){
		rem_h--;
		rem_min = 60 + set_min - loc_time->tm_min;
    }
    else{
		rem_min = set_min - loc_time->tm_min;
    }
	
    if(set_h < loc_time->tm_hour){
		rem_d--;
		rem_h += 24 + set_h - loc_time->tm_hour;
    }
    else{
		rem_h += (set_h - loc_time->tm_hour);
    }

    if(rem_h < 0){
		rem_d--;
		rem_h += 24;
    }

	rem_sec = 60 - loc_time->tm_sec;
	rem_min = rem_min - 1;

/*	printf("rem_d = %d\n", rem_d);
	printf("rem_h = %d\n", rem_h);
	printf("rem_m = %d\n", rem_min);
	printf("rem_sec = %d\n", rem_sec);
	
	printf("%d\n", ((rem_d * 24 + rem_h) * 60 + rem_min) * 60 + rem_sec);
	exit(0);  */

	return (((rem_d * 24 + rem_h) * 60 + rem_min) * 60 + rem_sec);

#endif


}
