#include  <stdio.h>
#ifdef NEWS
#include  "Nstdio.h"
#include  <stdarg.h>
#include  "Nstdarg.h"
#endif
#include  <stdlib.h>
#include  <unistd.h>
#include  <time.h>
#include  <sys/time.h>
#include  "countd.h"
#include  "disp_ctr.h"
#include  "delay.h"


int main(int argc, char *argv[])
{
	time_t diff; /*  ߻狼餷᤭ޤǤ  */
	struct tm sime_tms;
	int s_year;  /*  ᤭ǯ  */
	int s_month; /*  ᤭  */
	int s_day;   /*  ᤭  */
	int s_hour;  /*  ᤭  */
	int s_min;   /*  ᤭ʬ  */
  	unsigned int update;  /*    */
	char subj[LEN];

	long day;   /*  Ĥ  */
	long hour;  /*  Ĥ  */
	long min;   /*  Ĥʬ  */
	long sec;   /*  Ĥ  */
	int loop;  /*  롼ѿ  */
	int num_color;  /*  Ĥɽ  */
	DEAD_COLOR dc[8];
	int i;


    title();

	
	if(argc == 2){
		if(load_cfg(argv[1], subj, &sime_tms, 
					&s_year, &s_month, &s_day, &s_hour, &s_min,
					&update, dc) == -1){
			return -1;
		}
	}
	else if(argc != 8){
		usage();
		return 0;
    }
	else{
		s_year  = atoi(argv[2]);
		s_month = atoi(argv[3]);
		s_day   = atoi(argv[4]);
		s_hour  = atoi(argv[5]);
		s_min   = atoi(argv[6]);
		sscanf(argv[7], "%u", &update);
		strcpy(subj, argv[1]);

		dc[0].color = AKA;
		dc[0].sec = 60 * 60 * 24 * 3;  /*  3 ֿɽ  */
		dc[1].color = MURASAKI;
		dc[1].sec = 60 * 60 * 24 * 7;  /*  7 翧ɽ  */
		dc[2].color = KIIRO;
		dc[2].sec = 60 * 60 * 24 * 14; /* 14 鲫ɽ  */
		dc[3].color = MIDORI;
		dc[3].sec = 60 * 60 * 24 * 21; /* 21 пɽ  */
		dc[4].color = MIZUIRO;
		dc[4].sec = 60 * 60 * 24 * 30; /* 30 忧ɽ  */
	}


/*  ڤΡ1970 ǯ 1  1  0  0 ʬ 0 ä  */
/*  вä뤿ν                              */
	sime_tms.tm_sec = 0;	        /* seconds (0 - 60) */
	sime_tms.tm_min = s_min;	    /* minutes (0 - 59) */
	sime_tms.tm_hour= s_hour;       /* hours (0 - 23)   */
	sime_tms.tm_mday= s_day;        /* day of month (1 - 31)  */
	sime_tms.tm_mon = s_month - 1;  /* month of year (0 - 11) */
	sime_tms.tm_year= s_year - 1900;/* year - 1900 */
	sime_tms.tm_wday;    /* day of week (Sunday = 0) */
	sime_tms.tm_yday;    /* day of year (0 - 365) */
	sime_tms.tm_isdst = -1;   /* is summer time in effect? */
#ifndef __linux__  /*  Linux ξ硢ΥФʤ  */
	sime_tms.tm_zone;  /* abbreviation of timezone name */
	sime_tms.tm_gmtoff; /* offset from UTC in seconds */
#endif

	diff = calc_diff(&sime_tms);

	if(diff >= (time_t)(60L * 60L * 24L * 730L)){
		rc_printf(4, "ޤɤߤǤ褤\n");
		rc_printf(4, "\tˤȤäƤФ졼\n");
		return 0;
	}
	else if(diff < 0){
		rc_printf(2, "\n%s ϲ᤮ޤ\n", subj);
		return 0;
	}
	else if(diff >= 0L){
		rc_printf(-1, "%s", subj);
		rc_printf(-1, "ޤǡ\n\n\n\n\n\n\n\n");
	}

	
	loop = (int)update;

	do{
		diff = calc_diff(&sime_tms);

		sec = diff % 60L;
		min = diff / 60L;
		hour= min / 60L;
		min = min % 60L;
		day = hour / 24L;
		hour= hour % 24L;

		if(diff <= 0){
			rel_xy(0, FIRST_Y - 1);
			for(i = 0; i < 8; i++){
				clr_to_right();
				rel_xy(0, 1);
			}
			rel_xy(0, FIRST_Y);
			rc_printf(2, "%s ᤮ޤ\n", subj);
			for(i = 0; i < 16; i++){
				printf("\7");
				fflush(stdout);
				delay(125);
			}
			break;
		}

		num_color = get_color(diff, dc);
		if(day > 0){
			rel_xyrc_num_disp(FIRST_X, FIRST_Y, num_color, day);
			clr_right_str("");

			rel_xyrc_num_disp(SECOND_X, SECOND_Y, num_color, hour);
			clr_right_str("֤");

			rel_xyrc_num_disp(SECOND_X, SECOND_Y, num_color, min);
			clr_right_str("ʬ");

			rel_xyrc_num_disp(SECOND_X, SECOND_Y, num_color, sec);
			clr_right_str("äǤ\n");
			fflush(stdout);
		}			
		else if(hour > 0){
			rel_xyrc_num_disp(FIRST_X, FIRST_Y, num_color, hour);
			clr_right_str("֤");

			rel_xyrc_num_disp(SECOND_X, SECOND_Y, num_color, min);
			clr_right_str("ʬ");

			rel_xyrc_num_disp(SECOND_X, SECOND_Y, num_color, sec);
			clr_right_str("äǤ\n");
		}
		else if(min > 0){
			rel_xyrc_num_disp(FIRST_X, FIRST_Y, num_color, min);
			clr_right_str("ʬ");
			
			rel_xyrc_num_disp(SECOND_X, SECOND_Y, num_color, sec);
			clr_right_str("äǤ\n");
		}
		else if(sec > 0){
			rel_xyrc_num_disp(FIRST_X, FIRST_Y, num_color, sec);
			clr_right_str("äǤ\n");
			if(sec <= 3){
				printf("\7");
				fflush(stdout);
			}
		}

		if(update != 0){
			if(((sec % 60) % update) == 0){
				sleep(update);
			}
			else{
				sleep((sec % 60) % update);
			}
		}

	}while(loop);
	

	return 0;
}


