#define	VER 1.00
#define LEN 256

#define  FIRST_X    2
#define  FIRST_Y   -7
#define  SECOND_X   1
#define  SECOND_Y  -6

#define  KURO     0
#define  AO       1
#define  AKA      2
#define  MURASAKI 3
#define  MIDORI   4
#define  MIZUIRO  5
#define  KIIRO    6
#define  SIRO     7


typedef struct dead_color{
	int color;
	long sec;
}DEAD_COLOR;


/*  title.c  */
void title(void);

/*  usage.c  */
void usage(void);

/*  getcolor.c  */
int get_color(time_t diff, DEAD_COLOR dc[]);

/*  num_disp.c  */
void rel_xyrc_num_disp(int x, int y, int c, int num);

/*  calcdiff.c  */
time_t calc_diff(struct tm *sime_tms);

/* clr_byou.c  */
void clr_right_str(char *str);

/*  load_cfg.c  */
int load_cfg(char *cfg_name, char *subj, struct tm *sime_tmsp,
			 int *s_year, int *s_mon, int *s_day, int *s_hour, int *s_min,
			 unsigned int *update,DEAD_COLOR dc[]);
