#define 	ESC			0x1b

/***  disp_ctr.h vg^Cv錾@***/
int cursor_off(void);
int cursor_on(void);
int fk_off(void);
int fk_on(void);
int save_xy_attr(void);
int restore(void);
int graph_char_on(void);
int graph_char_off(void);
int spacing_on(void);
int spacing_off(void);
int color(int num);
int color_s(int num, char *buf);
int r_color(int num);
int b_color(int num);
int br_color(int num);
int xy(int x, int y);
int c_printf(int c, char *format, ...);
int rc_printf(int c, char *format, ...);
int bc_printf(int c, char *format, ...);
int brc_printf(int c, char *format, ...);
int xy_printf(int x, int y, char *format, ...);
int xyc_printf(int x, int y, int c, char *format, ...);
int xyrc_printf(int x, int y, int c, char *format, ...);
int xybc_printf(int x, int y, int c, char *format, ...);
int xybrc_printf(int x, int y, int c, char *format, ...);
int c_scanf(int c, char *format, ...);
int rc_scanf(int c, char *format, ...);
int bc_scanf(int c, char *format, ...);
int brc_scanf(int c, char *format, ...);
int xy_scanf(int x, int y, char *format, ...);
int xyc_scanf(int x, int y, int c, char *format, ...);
int xyrc_scanf(int x, int y, int c, char *format, ...);
int xybc_scanf(int x, int y, int c, char *format, ...);
int xybrc_scanf(int x, int y, int c, char *format, ...);
int clr_to_right(void);
int xy_clr_to_right(int x, int y);
int clr_to_left(void);
int xy_clr_to_left(int x, int y);
int clr_line(void);
int xy_clr_line(int x, int y);
int cls(void);
void clr_w_y(int ys, int ye);
void clr_w_x(int xs, int xe);
void clr_w_xy(int left, int top, int right, int bottom);
int c_fprintf(int c, FILE *fp, char *format, ...);
int rc_fprintf(int c, FILE *fp, char *format, ...);
int bc_fprintf(int c, FILE *fp, char *format, ...);
int brc_fprintf(int c, FILE *fp, char *format, ...);
int xy_fprintf(int x, int y, FILE *fp, char *format, ...);
int xyc_fprintf(int x, int y, int c, FILE *fp, char *format, ...);
int xyrc_fprintf(int x, int y, int c, FILE *fp, char *format, ...);
int xybc_fprintf(int x, int y, int c, FILE *fp, char *format, ...);
int xybrc_fprintf(int x, int y, int c, FILE *fp, char *format, ...);
int c_sprintf(int c, char *buf, char *format, ...);
int del_line(int l);
int xy_del_line(int x, int y, int l);
int ins_line(int l);
int xy_ins_line(int x, int y, int l);
int up_no_scroll(int y);
int down_no_scroll(int y);
int right(int x);
int left(int x);
int clr_to_right_bottom(void);
int xy_clr_to_right_bottom(int x, int y);
int clr_to_left_top(void);
int one_down(void);
int one_down_left_end(void);
int one_up(void);
int up(int y);
int down(int y);
int rel_xy(int x, int y);
int rel_x(int x);
int rel_xy_printf(int x, int y, char *format, ...);
int rel_xyc_printf(int x, int y, int c, char *format, ...);
int rel_xyrc_printf(int x, int y, int c, char *format, ...);
int rel_xybc_printf(int x, int y, int c, char *format, ...);
int rel_xybrc_printf(int x, int y, int c, char *format, ...);
int rel_xy_fprintf(int x, int y, FILE *fp, char *format, ...);
int rel_xyc_fprintf(int x, int y, int c, FILE *fp, char *format, ...);
int rel_xyrc_fprintf(int x, int y, int c, FILE *fp, char *format, ...);
int rel_xybc_fprintf(int x, int y, int c, FILE *fp, char *format, ...);
int rel_xybrc_fprintf(int x, int y, int c, FILE *fp, char *format, ...);
int centering_cprintf(int dc, int c, char *format, ...);
int centering_cfprintf(int dc, int c, FILE *fp, char *format, ...);
int cursor_report(int *x, int *y);

int xy_puts(int x, int y, char *str);



