#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>
#include  "getln.h"
#ifdef NEWS
#include  "fseek.h"
#endif

/*============================================================================
֐            getln
@\              t@C̘_I 1 sǂݍ
l^
    buf: ǂݍ݃obt@ւ̃|C^̃AhX
    len: ǂݍ݃obt@̒i[ϐ̃AhX
    fp : getln œǂݍރt@Cւ̃t@C|C^

l󂯎
    buf: t@Cǂݏo_I 1 s
         (obt@̖ɂ͉sR[h݂)
    len: buf ɁǍ݂тĂǂݍ݃obt@̒
    fp : getln ďoɎwĂs̎̍s̐擪

Ԃl            
     -> ǂݍ񂾕(sR[hɊ܂)
       0 -> t@C̏I(End of file)ɒB
            (̂ƂAbuf ɌтĂ͉̈)
      -1 -> 炩̃G[
            (GETLN_MSG 萔`Ă΁A
             G[bZ[W\B)

쐬            r
쐬N        1997- 4-??
C          
CN      
l
============================================================================*/

int getln(char **buf, int *len, FILE *fp)
{
	long before_loc;


	if(*buf == (char *)NULL){
		*buf = (char *)malloc(sizeof(char) * GETLN_BUFLEN);
		*len = GETLN_BUFLEN;
		if(*buf == (char *)NULL){
#ifdef  GETLN_MSG
			fprintf(stderr, "Can't allcate memory for buffer in function getln()!\n");
#endif
			return -1;
		}
	}

	
	if((before_loc = ftell(fp)) == -1L){
#ifdef GETLN_MSG
		fprintf(stderr, "Can't get location of current file pointer!\n");
#endif
		return -1;
	}

	while(1){
		if(fgets(*buf, *len, fp) == NULL){
			free(*buf);
			return 0;  /*  0 -> EOF  */
		}
		
		if(*(*buf + (strlen(*buf)-1)) != '\n'){ /*  buf <= t@C 1 s  */
			if(fseek(fp, before_loc, SEEK_SET) != 0){
#ifdef GETLN_MSG
				rc_printf(2, "file seek error in function getln()!\n");
#endif
				return -1;
			}

			if((*buf = realloc(*buf, (*len = (*(len) * 2)))) == NULL){
#ifdef GETLN_MSG
				rc_printf(2, "Can't realloc buffer in function getln()!\n");
#endif
				return -1;
			}
		}
		else{
			return strlen(*buf);
		}
	}
}
